function [xs, ts, Xf, Xsf]=graficar(x, t, Fsa, Fs, tmax, Fmax, tono)

% x seal analogica
% t base temporal
% Fsa frecuencia de sampleo analogica (truco)
% Fs frecuencia de sampleo
% tmax tiempo maximo para las graficas temporales
% Fmax frecuencia maxima para las graficas frecuenciales
% tono ~= F1    grafica tono del alias  (F1 contiene la frecuencia del tono)
%       =0      no grafica alias

Fmax=Fmax*2;
ts=0:1/Fs:t(end);
ts=ts(1:end);
xs=interp1(t,x,ts);

figure(1)
if tono ==0
    plot(t,x,'-',ts,xs,'.')
    axis([0 tmax -1 1]) 
    xlabel('time [s]')  
    ylabel('x')
    texto=sprintf('Seal analogica sampleada a %d Hz',Fs);
    title(texto)
    legend('Seal analogica','Seal sampleada',0)

else
    if tono<=Fs/2
        disp('No hay aliasing')
        plot(t,x,'-',ts,xs,'r.',t,cos(2*pi*tono*t),'r:')
    else
        disp('Hay aliasing')
        plot(t,x,'-',ts,xs,'r.',t,cos(2*pi*(Fs-tono)*t),'r:')
    end
    axis([0 tmax -1 1]) 
    xlabel('time [s]')  
    ylabel('x')
    texto=sprintf('Tono de %d Hz sampleado a %d Hz',tono,Fs);
    title(texto)
    legend('Seal analogica','Muestras','Seal sampleada',0)
end
    

%Discrete Fourier Transform de la senal analogica
[Xf]=fft(x);
Xf=fftshift(Xf);
f=([1:length(Xf)]/length(Xf)-.5)*Fsa;

[Xsf]=fft(xs);
Xsf=fftshift(Xsf);
fs=([1:length(Xsf)]/length(Xsf)-.5)*Fs;

figure(2)
subplot(221), plot(f,abs(Xf)/Fsa/t(end))
aux=axis;
axis([-Fmax/2 Fmax/2 aux(3) aux(4)])
xlabel('Frecuency [Hz]')
ylabel('|X(f)|')
subplot(222), plot(f,(angle(Xf)))
aux1=axis;
axis([-Fmax/2 Fmax/2 aux1(3) aux1(4)])
xlabel('Frecuency [Hz]')
ylabel('angle(X(f))')

subplot(223), plot(fs,abs(Xsf)/Fs/t(end))
axis([-Fmax/2 Fmax/2 aux(3) aux(4)])
xlabel('Frecuency [Hz]')
ylabel('|X_s(f)|')
subplot(224), plot(fs,(angle(Xsf)))
aux=axis;
axis([-Fmax/2 Fmax/2 aux1(3) aux1(4)])
xlabel('Frecuency [Hz]')
ylabel('angle(X_s(f))')
